package org.example.dfsort;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

public class InputHandler 
{
	private static final Logger LOG = Logger.getLogger(InputHandler.class);
	private List<String> fileData = new ArrayList<String>();
	
	// a method to read the file and build the list
	public void readFile(String fileName)
	{
		if (fileName == null)
		{
			throw new IllegalArgumentException("A File Name is required");
		}
		String currentDir = System.getProperty("user.dir");
		File dataFile = new File(currentDir +
				File.separator + "data" +
				File.separator + fileName);
		try 
		{
			BufferedReader in =
					new BufferedReader(new FileReader(dataFile));
			String data = null;
			while (true)
			{
				data = in.readLine();
				LOG.trace("read: " + data);
				if (data == null)
				{
					break;
				}
				fileData.add(data);
			}
			in.close();
		}
		catch(Exception e)
		{
			throw new RuntimeException(e.toString());
		}

	}
	
	// a method to pull one from the list
   public String getRecord(int index)
   {
	   if (index < 0 || index > getSize())
	   {
		   throw new IllegalArgumentException("Requested record is out of range");
	   }
	   LOG.trace("returning record: " + index);
	   return fileData.get(index);
   }
   
   // a method to return the number of records
   public int getSize()
   {
	   return fileData.size();
   }
}
